/*#######################################################################################
Timer0 Functions

Copyright (C) 2005 Branko Golubovic
branko.golubovic@gmx.at
#######################################################################################*/

#include	"main.h"
#include	"timer0.h"


volatile unsigned char syncbute=0;
volatile unsigned char ss	= 0; //Variable fr Sekunden
volatile unsigned char mm	= 51;//Variable fr Minuten
volatile unsigned char hh	= 9;//Variable fr Stunden
static unsigned char Keysync_counter,Clocksync_counter;

void timer0_init(void)
{	
	OCR0=250;// Interrupt Period 4mS
	timer_enable_int(1<<OCIE0);// Output Compare Interrupt Enable 0
	TCCR0=(0<<CS00)|(0<<CS01)|(1<<CS02)|(1<<WGM01);	// Timer0 Clock=SYSCLK/256,CTC,Timer Start
	
}

void timer0_stop(void)
{
	TCCR0&=~((1<<CS00)|(1<<CS01)|(1<<CS02));	// Timer0 Stop
}

void timer0_start(void)
{
	TCCR0=(1<<CS00)|(1<<CS01)|(1<<CS02);	// Timer0 Start
}

#if defined USE_T0_OVERFLOW
SIGNAL (SIG_OVERFLOW0 )
{	

}
#endif


#if defined USE_OC0_INTERRUPT
SIGNAL (SIG_OUTPUT_COMPARE0)
{ 
	Keysync_counter++;
	Clocksync_counter++;
	if(Keysync_counter==KEYCOUNT)// KEYCOUNT*4mS 
	{
		syncbute|=(1<<KEYSYNC); 		// Set Keysunc Flag
		Keysync_counter=0;					// Reset Keysync Counter
	}

	if(Clocksync_counter==CLOCKCOUNT) //250*4mS=1S 
	{
		syncbute|=(1<<CLOCKSYNC);	// Set Clocksunc Flag
		Clocksync_counter=0;				// Reset Clockync Counter
			ss++;//Addiere +1
	if (ss == 60)
		{
		ss = 0;
		mm++;//Addiere +1
		if (mm == 60)
			{
			mm = 0;
			hh++;//Addiere +1
			if (hh == 24)
				{
				hh = 0;
				}
			}
		
		}
	}
}
#endif